import json
import os

def load_setting(conf_file):
    global port, feature_extractor, k, k_reorder, img_folder, log_folder, logs, working_folder, data_folder, DATASET_GEM, DATASET1, DATASET2, DATASET_LF, DATASET_IDS, DATASET_BEBLID, DATASET_LATCH

    with open(conf_file) as settings_file:

        settings = json.load(settings_file)

        port = settings['port']
        feature_extractor = settings['fe_service']

        k = settings['k']
        k_reorder = settings['k_reorder']
        working_folder =  settings['working_folder']

        data_folder = os.path.join(working_folder, settings['data_folder'])

        if not os.path.isdir(data_folder):
            os.mkdir(data_folder)

        DATASET_GEM = os.path.join(data_folder, 'gem.npy')
        #DATASET1 = os.path.join(data_folder, 'dataset_resized.npy')
        #DATASET2 = os.path.join(data_folder, 'dataset_bw.npy')
        #DATASET_LF = os.path.join(data_folder, 'dataset_lf.dat')
        #DATASET_LF = os.path.join(data_folder, 'orb_5k.dat')
        DATASET_IDS = os.path.join(data_folder, 'dataset.ids')
        #DATASET_BEBLID = os.path.join(data_folder, 'dataset_beblid.dat')
        DATASET_BEBLID = os.path.join(data_folder, 'beblid.dat')
        #DATASET_LATCH = os.path.join(data_folder, 'dataset_latch.dat')
        #DATASET_LATCH = os.path.join(data_folder, 'latch_5k.dat')

        img_folder = settings['img_folder']
        log_folder = settings['log_folder']
        #temporary for mobile app debugging
        log_folder = settings['log_folder']
        log_folder = '/home/paolo/Dropbox/extension_logs'
        logs = os.path.join(working_folder, log_folder)
        if not os.path.isdir(logs):
            os.mkdir(logs)
