import cv2
from pathlib import Path
import tqdm
import pickle
import os

import LFUtilities
import ORBParameters as params

orb = cv2.ORB.create(params.KEYPOINTS)


def extract(img_path):
    img = LFUtilities.resize(params.IMG_SIZE, cv2.imread(img_path))
    kp, des = orb.detectAndCompute(img, mask=None)
    return (kp, des)

